!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>Searching Algorithms</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/black.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>
		<div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>

        <div class="reveal">
            <div class="slides">
                <!-- Introduction Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                    <section>
                        <h1>Searching Algorithms</h1>    
                    </section>
                    <section>
                        <h2>Searching Algorithms Overview</h2>
                    </section>
                    <section>
                        <h2>Objectives</h2>
					</section>
					<section>
						<h2>Searchingn Algorithms</h2>
						<ul>
							<li>
								Linear search
							</li>
							<li>Binary Search</li>
						</ul>
						
					</section>
                </section>
                <!-- Coding Style Guide Section -->
                <section>   
                    <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
						<h2>Linear Search</h2>
						<p>Linear search is the simplest searching algorithm that searches for an element in a list in sequential order</p>
		
						<aside class="notes">
							Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for
							instructor view!!
						</aside>
					</section>
					<section>
						<h2>Linear search Algorithm</h2>
						<pre>
							<code data-trim data-noescape>
								Linear Search ( Array A, Value x)

								Step 1: Set i to 1
								Step 2: if i > n then go to step 7
								Step 3: if A[i] = x then go to step 6
								Step 4: Set i to i + 1
								Step 5: Go to Step 2
								Step 6: Print Element x Found at index i and go to step 8
								Step 7: Print element not found
								Step 8: Exit
							</code>
						</pre>
					</section>
					<section>
						<h2>Linear search pseudocode </h2>
							<pre>
							<code data-trim data-noescape>
								procedure linear_search (list, value)

									for each item in the list
										if match item == value
											return the item's location
										end if
									end for

								end procedure
							</code>
						</pre>
					</section>
					<section>
						<h2>Linear search implementation</h2>
						<pre>
							<code data-trim data-noescape>
								#include stdio.h
  
									int main()
									{
										int a[20],i,x,n;
										printf("How many elements?");
										scanf("%d",&n);
										 
										printf("Enter array elements:n");
										for(i=0;i << n;++i)
											scanf("%d",&a[i]);
										 
										printf("nEnter element to search:");
										scanf("%d",&x);
										 
										for(i=0;i << n;++i)
											if(a[i]==x)
												break;
										 
										if(i << n)
											printf("Element found at index %d",i);
										else
											printf("Element not found");
									  
										return 0;
									}

							</code>
						</pre>
					</section>
					<section>
						<h2>Linear search time complexity</h2>
						<p>The time complexity of a linear search is O(n).</p>
					</section>
		
					
                </section>
                <!-- Arrays Section -->
                <section>
                    <section>
                        <h2>Binary Search Algorithm</h2>
						<ul>
							<li>Binary Search is a searching algorithm for finding an element's position in a sorted array</li>

						</ul>
                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
						<h2>Binary Search Algorithm</h2>
						<pre>
							<code data-trim data-noescape>
								Compare x with the middle element.
								If x matches with middle element, we return the mid index.
								Else If x is greater than the mid element, then x can only lie in right half subarray after the mid element. So we recur for right half.
								Else (x is smaller) recur for the left half

							</code>
						</pre>
					</section>
					<section>
						<h3>Binary Search Example</h3>
						<pre>
							<code>
						do until the pointers low and high meet each other.
							mid = (low + high)/2
							if (x == arr[mid])
								return mid
							else if (x > A[mid]) // x is on the right side
								low = mid + 1
							else                       // x is on the left side
								high = mid - 1
							</code>
						</pre>
				</section>
                </section>
                <!-- Access & Modify Arrays Section -->
                <section>
                    <section>
						<h2>Binary Search Demo Example</h2>
						

						
						<aside class="notes">
							Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for
							instructor view!!
						</aside>

                        
					</section>
					
                </section>
                <!-- Strings Section -->
                <section>
                    <section>
						<h2>Review</h2>
						
                    </section>
                  
                </section>
                <!-- String Methods Section -->
                <section>
                    <section>
                        <h2>Review</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                  
                </section>
                <!-- Conclusion Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>Questions?</h2>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                        <h2>Summary</h2>
                        <ul>
                            <li>List</li>
                        </ul>
                    </section>
                </section>
            </div>
        </div>

        <footer style="background:green; left:0; right:0; bottom: 0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer>	
			
			
		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				hash: true,
				menu: {
					// Specifies which side of the presentation the menu will 
					// be shown. Use 'left' or 'right'.
					side: 'left',

					// Specifies the width of the menu.
					// Can be one of the following:
					// 'normal', 'wide', 'third', 'half', 'full', or
					// any valid css length value
					width: 'normal',

					// Add slide numbers to the titles in the slide list.
					// Use 'true' or format string (same as reveal.js slide numbers)
					numbers: true,

					// Specifies which slide elements will be used for generating
					// the slide titles in the menu. The default selects the first
					// heading element found in the slide, but you can specify any
					// valid css selector and the text from the first matching
					// element will be used.
					// Note: that a section data-menu-title attribute or an element
					// with a menu-title class will take precedence over this option
					titleSelector: 'h1, h2, h3, h4, h5, h6',

        // If slides do not have a matching title, attempt to use the
        // start of the text content as the title instead
        useTextContentForMissingTitles: false,

        // Hide slides from the menu that do not have a title.
        // Set to 'true' to only list slides with titles.
        hideMissingTitles: false,

        // Adds markers to the slide titles to indicate the 
        // progress through the presentation. Set to 'false'
        // to hide the markers.
        markers: true,

        // Specify custom panels to be included in the menu, by
        // providing an array of objects with 'title', 'icon'
        // properties, and either a 'src' or 'content' property.
        custom: false,

        // Specifies the themes that will be available in the themes
        // menu panel. Set to 'true' to show the themes menu panel
        // with the default themes list. Alternatively, provide an
        // array to specify the themes to make available in the
        // themes menu panel, for example...
        // [
        //     { name: 'Black', theme: 'css/theme/black.css' },
        //     { name: 'White', theme: 'css/theme/white.css' },
        //     { name: 'League', theme: 'css/theme/league.css' }
        // ]
        themes: true,

        // Specifies the path to the default theme files. If your
        // presentation uses a different path to the standard reveal
        // layout then you need to provide this option, but only
        // when 'themes' is set to 'true'. If you provide your own 
        // list of themes or 'themes' is set to 'false' the 
        // 'themesPath' option is ignored.
        themesPath: 'css/theme/',

        // Specifies if the transitions menu panel will be shown.
        // Set to 'true' to show the transitions menu panel with
        // the default transitions list. Alternatively, provide an
        // array to specify the transitions to make available in
        // the transitions panel, for example...
        // ['None', 'Fade', 'Slide']
        transitions: true,

        // Adds a menu button to the slides to open the menu panel.
        // Set to 'false' to hide the button.
        openButton: true,

        // If 'true' allows the slide number in the presentation to
        // open the menu panel. The reveal.js slideNumber option must 
        // be displayed for this to take effect
        openSlideNumber: true,

        // If true allows the user to open and navigate the menu using
        // the keyboard. Standard keyboard interaction with reveal
        // will be disabled while the menu is open.
        keyboard: true,

        // Normally the menu will close on user actions such as
        // selecting a menu item, or clicking the presentation area.
        // If 'true', the sticky option will leave the menu open
        // until it is explicitly closed, that is, using the close
        // button or pressing the ESC or m key (when the keyboard 
        // interaction option is enabled).
        sticky: true,

        // If 'true' standard menu items will be automatically opened
        // when navigating using the keyboard. Note: this only takes 
        // effect when both the 'keyboard' and 'sticky' options are enabled.
        autoOpen: true,

        // If 'true' the menu will not be created until it is explicitly
        // requested by calling RevealMenu.init(). Note this will delay
        // the creation of all menu panels, including custom panels, and
        // the menu button.
        delayInit: false,

        // If 'true' the menu will be shown when the menu is initialised.
        openOnInit: false,

        // By default the menu will load it's own font-awesome library
        // icons. If your presentation needs to load a different
        // font-awesome library the 'loadIcons' option can be set to false
        // and the menu will not attempt to load the font-awesome library.
        loadIcons: true
    },
    dependencies: [
        { src: 'plugin/markdown/marked.js' },
        { src: 'plugin/markdown/markdown.js' },
        { src: 'plugin/highlight/highlight.js' },
        { src: 'plugin/notes/notes.js', async: true },
        { src: 'plugin/reveal.js-menu/menu.js' }
    ]
});
</script>
</body>
</html>
